%% Create diagnosis system class

% Create diagnosis system. 
DS = ExampleDiagnosisSystem(); %% change to your class here

%% Initialize diagnosis system
% You can initialize the diagnosis system by loading a parameter file
DS.Initialize(); %% Initialize diagnosis system

%% Evaluate diagnosis system

% Load test data
test_data = readtable("../data/trainingdata/wltp_f_waf_110.csv");

% Log diagnosis output
fileID = fopen("output.csv",'w');
fprintf(fileID, 'sample_time,computation_time,detection,fpic_rank,fpim_rank,fwaf_rank,fiml_rank,fx_rank\n');

for time_idx = 1:numel(test_data.time)
    tstart_iter = tic;

    % Feed sample to diagnosis system and return diagnosis output    
    [detection, isolation] = DS.Input(test_data(time_idx,:));
    
    time_iter = toc(tstart_iter); 
    % Log diagnosis output
    fprintf(fileID, '%f,%f,%d,%f,%f,%f,%f,%f\n', test_data.time(time_idx), time_iter, detection, isolation(1), isolation(2), isolation(3), isolation(4), isolation(5));

    % Print progress
    if mod(time_idx,1000) == 0
        fprintf('.');
    end
end

% Close logger
fileID = fclose(fileID);